<?
/*
 (c) 2003 Tassilo Erlewein <tassilo.erlewein@erfrakon.de>
 (c) 2003 Martin Konold <martin.konold@erfrakon.de>
 (c) 2004 Jean-Michel Dault <jmdault@mandrakesoft.com>
 This program is Free Software under the GNU General Public License (>=v2). 
 Read the file COPYING that comes with this packages for details.
*/
    include("head.php");

    This("addressbook/create_vcard.php?action=create");

    Head();

    include("../include/checks.php");
?>

<TABLE WIDTH="100%" CELLSPACING=0 CELLPADDING=0 BORDER=0>

<?
function debug ($a) 
{
//   print "debug: $a<br>\n";
}

debug("debug is on");

$errors = array();
$valid_actions = array('firstsave','save','modify','create','delete','kill');

if (!empty($HTTP_GET_VARS['action']) && 
    in_array($HTTP_GET_VARS['action'],$valid_actions)) $action = trim(urldecode($HTTP_GET_VARS['action']));
   else array_push($errors, "Error: need valid action to proceed");

$dn="";
if (!empty($HTTP_GET_VARS['dn'])) $dn = trim(urldecode($HTTP_GET_VARS['dn']));

if (!($uid = $_SERVER['PHP_AUTH_USER']) ||
    !($bind_dn = uid2dn($uid)) ||
    !($group = uid2group($uid)))
   array_push($errors, "Internal Error: could not get Authentication Information");

if (!$errors && $group != "maintainer" && $group != "admin") 
   array_push($errors, "Error: You don't have the required Permissions"); 

debug("givenuid=$uid, bind_dn=$bind_dn, dn='$dn', group=$group");

$myself = $_SERVER['PHP_SELF'];

if (!empty($_SESSION['ldap_server'])) $ldap_server = $_SESSION['ldap_server'];
   else $ldap_server = '127.0.0.1';

if (!empty($_SESSION['ldap_port'])) $ldap_port = $_SESSION['ldap_port'];
   else $ldap_port = 389;

$attributes = array( 'title', 'cn', 'sn', 'mail', 'alias', 'o',
                     'ou', 'roomNumber', 'street', 'postOfficeBox',
                     'postalCode', 'l', 'c', 'telephoneNumber',
                     'facsimileTelephoneNumber' );

$utf8 = array ( 'cn', 'title', 'o', 'ou', 'roomNumber', 'street', 'sn',
                'postOfficeBox', 'postalCode', 'l', 'c', 'telephoneNumber',
                'facsimileTelephoneNumber' );

function to_utf8 ($a)
{
   global $utf8;
   global $attributes;
   foreach ($attributes as $attr) {
      if (!in_array($attr,$utf8) || empty($a[$attr])) continue;
      if (is_array($a[$attr])) {
         $index = 0;
         while (!empty($a[$attr][$index])) {
            $a[$attr][$index] = utf8_encode($a[$attr][$index]);
            $index++;
         }
      } elseif (!empty($a[$attr])) $a[$attr] = utf8_encode($a[$attr]);
   }
   return $a;
}

function from_utf8 ($a)
{
   global $utf8;
   global $attributes;
   foreach ($attributes as $attr) {
      if (!in_array($attr,$utf8) || empty($a[$attr])) continue;
      if (is_array($a[$attr])) {
         $index = 0;
         while (!empty($a[$attr][$index])) {
            $a[$attr][$index] = utf8_decode($a[$attr][$index]);
            $index++;
         }
      } elseif (!empty($a[$attr])) $a[$attr] = utf8_decode($a[$attr]);
   }
   return $a;
}

function fill_up($a)
{
   global $attributes;
   foreach ($attributes as $attr) {
      if (empty($a[$attr])) $a[$attr] = array();
   }
   return $a;
}

function fill_up2 ($a)
{
   global $attributes;
   foreach ($attributes as $attr) {
      if (empty($a[$attr])) $a[$attr] = array(0 => "", 'count' => 1);
   }
   return $a;
}

$noshow = array('cn','sn');

function noshow($a)
{
   global $noshow;
   return in_array($a, $noshow); 
}

$beautify = array (
      'c' => 'Country', 'l' => 'City', 'street' => 'Street Address', 'telephoneNumber' => 'Telephone Number',
      'postOfficeBox' => 'Postbox', 'postalCode' => 'Postal Code', 'ou' => 'Organizational Unit',
      'o' => 'Organization', 'roomNumber' => 'Room Number', 'title' => 'Title', 'cn' => 'Name',
      'sn' => 'Surname', 'facsimileTelephoneNumber' => 'Fax Number', 'mail' => 'Primary E-Mail Address',
      'alias' => 'E-Mail Alias', 'firstname' => 'First Name', 'lastname' => 'Last Name');

function dobeautify ($a)
{
   global $beautify;
   if (array_key_exists($a, $beautify)) return $beautify[$a];
   return $a;
}

$comment = array( 'firstname' => 'Required', 'sn_0' => 'Required' );

function comment ($a)
{
   global $comment;
   if (array_key_exists($a, $comment)) return $comment[$a];
   return '';
}

$firstname = "";
$lastname = "";
$password_0 = "";
$password_1 = "";
$domain = "";
$domain_dn = "";

$missing_input = 0;

function missing_input ()
{
   global $missing_input;
   global $errors;
   
   if (!$missing_input) {
      $missing_input++;
      array_push($errors, "Error: Input required");
   }
}

$ldap_object = array('objectClass' => array("inetOrgPerson", "top", "kolabInetOrgPerson"));

//JMD: use myldap_connect
if (!$errors && (!($link = myldap_connect($ldap_server,$ldap_port)) || 
    !ldap_bind($link, $bind_dn, $_SERVER["PHP_AUTH_PW"])))
   array_push($errors, "Communication Error: could bind to ldap://$ldap_server:$ldap_port ".ldap_error($link));
if (!$errors) {
   // ldap_set_option($link, LDAP_OPT_PROTOCOL_VERSION, 3);
   /*if (($result = ldap_read($link, "k=kolab,".$_SESSION['base_dn'], "(objectclass=*)")) &&
       ($entry = ldap_first_entry($link,$result)) &&
       ($dattrs = ldap_get_attributes($link,$entry))) {

      $domain = $dattrs['mydomain'][0];
      $dcs = array_reverse(explode('.', $domain));
      $domain_dn = "k=kolab";
      foreach ($dcs as $dc) $domain_dn = "dc=$dc,".$domain_dn;
      $addressbook_root = "cn=external,".$domain_dn;

   } else array_push($errors, "LDAP Error: could not determin domain"); */
   $addressbook_root = "cn=external,".$_SESSION['base_dn'];

   if ($action == "kill") {

      if (!$dn) array_push($errors, "Error: need dn for delete operation");
         elseif ($group != "maintainer" && $group != "admin") 
            array_push($errors, "Error: you need administrative permissions to delete users");

      if (!$errors) {    
         print("<TR><TD><center><H1> Delete Address Book Entry </H1></center></TD></TR>\n");
         if (!(ldap_delete($link,$dn))) {
            array_push($errors, "LDAP Error: could not delete ".utf8_decode($dn)." ".ldap_error($link));
         } else {
            print("<tr><td><center> The object ".utf8_decode($dn)." has been deleted </td></tr>\n");
         }
      } 

   } else {

      switch ($action) {

         case "firstsave":
         case "save":
            if ($action == "save" && !$dn) array_push($errors, "Internal Error: need dn to save");
            if (!empty($HTTP_GET_VARS['firstname'])) {
               $firstname = trim(urldecode($HTTP_GET_VARS['firstname']));
            } else {
               $comment['firstname'] = "<span style=\"color:#FF0000\"> Fill in firstname </span>";
               missing_input();
            }
            if (!empty($HTTP_GET_VARS['lastname'])) {
               $ldap_object['sn'] = trim(urldecode($HTTP_GET_VARS['lastname']));
               if ($firstname) $ldap_object['cn'] = $firstname." ".$ldap_object['sn'];
            } else {
               $comment['lastname'] = "<span style=\"color:#FF0000\"> Fill in lastname </span>";
               missing_input();
            }
            foreach ($attributes as $attr) {
               if ($attr == 'sn' || $attr == 'cn') continue;
               $count = 0;
               $key = $attr."_0";
               $args = array();
               while (!empty($HTTP_GET_VARS[$key])) {
                  $args[$count] = trim(urldecode($HTTP_GET_VARS[$key]));
                  $count++;
                  $key = $attr."_".$count;
               }
               if ($count > 0) $ldap_object[$attr] = $args;
                  elseif (!empty($HTTP_GET_VARS[$key])) $ldap_object[$attr] = $HTTP_GET_VARS[$key];
            }

//print("ldap_object: "); print_r($ldap_object); print("<br>");

            $ldap_object = to_utf8($ldap_object);

            if ($action == "save") {
               if (!$errors) {
                  if (!empty($ldap_object['cn'])) $newdn = "cn=".$ldap_object['cn'].",".$addressbook_root;
                     else $newdn = $dn;
                  if (strcmp($dn,$newdn) != 0) {
                     if (($result=ldap_read($link,$dn,"(objectclass=*)")) &&
                         ($entry=ldap_first_entry($link,$result)) &&
                         ($oldattrs=ldap_get_attributes($link,$entry))) {
                        if (!ldap_add($link,$newdn, $ldap_object) || !ldap_delete($link,$dn))
                           array_push($errors, "LDAP Error: could not rename ".utf8_decode($dn).
			               " to ".utf8_decode($newdn)." ".ldap_error($link));
                        $dn = $newdn;
                     } else array_push($errors,"LDAP Error: could not read ".utf8_decode($dn)." ".ldap_error($link));
                  } else {
                     $ldap_object = fill_up($ldap_object);
                     if (!ldap_modify($link, $dn, $ldap_object))
                     array_push($errors, "LDAP Error: could not modify object ".utf8_decode($dn)." ".ldap_error($link)); 
                  }
               } 
            } else {
               if (!$errors) {
                  $dn = "cn=".$ldap_object['cn'].",".$addressbook_root;
                  if ($dn && !ldap_add($link, $dn, $ldap_object)) 
                     array_push($errors, "LDAP Error: could not add object ".utf8_decode($dn)." ".ldap_error($link));
               }
               if ($errors) {
                  print("<TR><TD><center><H1> Create New Address Book Entry </H1></center></TD></TR>\n");
		  $action = "create";
		  $ldap_object = from_utf8($ldap_object);
                  break;
               }
            }
            $action = "modify";
            print("<TR><TD><center><H1> Modify Existing Address Book Entry </H1></center></TD></TR>\n");
            break;

         case "create":
            print("<TR><TD><center><H1> Create New Address Book Entry </H1></center></TD></TR>\n");
            break;

         case "modify":
            print("<TR><TD><center><H1> Modify Existing Address Book Entry </H1></center></TD></TR>\n");
	    break;

	 case "delete":
	    print("<TR><TD><center><H1> Confirm Delete Address Book Entry </H1></center></TD></TR>\n");
      }

      if ($dn) {
         $ldap_object = array();
         if (($result = ldap_read($link, $dn, "(objectclass=*)")) &&
             ($entry = ldap_first_entry($link,$result)) &&
             ($ldap_object = ldap_get_attributes($link,$entry))) {
            $ldap_object = from_utf8($ldap_object);
            $ldap_object = fill_up2($ldap_object);
            ldap_free_result($result);
         } else array_push($errors, "LDAP Error: could not read ".utf8_decode($dn)." ".ldap_error($link));
      }
   }
   ldap_close($link);
}   

// print "ldap_object gelesen: "; print_r($ldap_object); print "<br>";

if ($action != "kill") {

print "<TR><TD><CENTER><form action=\"$myself\" method=\"GET\">\n";
switch ($action) {
   case "create":
      print("<input type=\"hidden\" name=\"action\" value=\"firstsave\">\n");
      break;
   case "delete":
      print("<input type=\"hidden\" name=\"action\" value=\"kill\">\n");
      break;
   default:
      print("<input type=\"hidden\" name=\"action\" value=\"save\">\n");
}
if ($dn) print "<input type=\"hidden\" name=\"dn\" value=\"$dn\">\n";
print "<table cellspacing=0 cellpadding=3>\n";

if (is_array($ldap_object['sn'])) $lastname = $ldap_object['sn'][0];
   else $lastname = $ldap_object['sn'];
if (is_array($ldap_object['cn'])) $cn = $ldap_object['cn'][0];
   else $cn = $ldap_object['cn'];
if ($lastname) {
   $a = strlen($lastname);
   if ($cn) {
      $b = strlen($cn);
      $firstname = substr($cn, 0, $b - $a);
   }
}

if ($action == "delete") print("<tr><th> Attribute </th><th> Value </th></tr>\n");
else print("<tr><th> Attribute </th><th> Value </th><th> Comment </th></tr>\n");
print "<tr><td> First Name </td><td>\n";
if ($action == "delete") print("$firstname </td></tr>\n");
else {
   print("<input type=\"text\" name=\"firstname\" size=25 maxlength=80 value=\"$firstname\">\n");
   print("</td><td>".(comment('firstname'))."</td></tr>\n");
}
print("<tr><td> Last Name </td><td>\n");
if ($action == "delete") print("$lastname </td></tr>\n");
else {
   print("<input type=\"text\" name=\"lastname\" size=25 maxlength=80 value=\"$lastname\">\n");
   print("</td><td>".(comment('sn_0'))."</td></tr>\n");
}

foreach ($attributes as $attr) {
   if (noshow($attr)) continue;
   if (!empty($ldap_object[$attr])) {
      if (is_array($ldap_object[$attr])) $value = $ldap_object[$attr];
         else $value = array(0 => $ldap_object[$attr], 'count' => 1);
   } else $value = array( 0 => "", 'count' => 1);
   for ($count=0; $count<$value['count']; $count++) {
      $battr = dobeautify($attr);
      print "<tr><td> $battr </td><td>\n";
      if ($action != "delete") {
         print "<input type=\"text\" name=\"".$attr."_".$count."\" size=25 maxlength=80 value=\"".$value[$count]."\">\n";
         print "</td><td>".(comment($attr."_".$count))."</td></tr>\n";
      } else print($value[$count]."</td></tr>\n");
      $count++;
   }
}
print "</table></CENTER></TD><TR>\n";

print "<tr><td><center><table cellspacing=0 cellpadding=3>\n";
print "<tr><td><input type=\"image\" src=\"../pics/button_ok.png\" name=\"apply\" value=\"Apply\"></td>\n";
if ($group == "user") {
   print "<td><a href=\"..\"> <img src=\"../pics/button_cancel.png\" alt=\"cancel\"></a></td></tr>\n";
} else {
   print "<td><a href=\"index.php\"> <img src=\"../pics/button_cancel.png\" alt=\"cancel\"></a></td></tr>\n";
}
print "</center></td></tr>\n";

} // if $action != delete

print("</table>\n");

if ($errors) {
   print("<TABLE WIDTH=\"100%\" CELLSPACING=20 CELLPADDING=0 BORDER=0>\n");
   print("<TR><TD HEIGHT=20></TD></TR>\n");
   print("<TR><TD><H3> There were Errors : </H3></TD></TR>\n");
   print("<TR><TD>\n");
   foreach ($errors as $message) print("<span style=\"color:#FF0000\">".$message."</span><br>");
   print("</TD></TR>\n");
   print("</TABLE>\n");
}
Foot();
?>
