<?

/*
 (c) 2005 Jean-Michel Dault <jmdault@mandrakesoft.com>
 This program is Free Software under the GNU General Public License (>=v2).
 Read the file COPYING that comes with this packages for details.
*/
//  include("../user/head.php");

$errors = array();

// check user authentication 
if (!($uid = $_SERVER["PHP_AUTH_USER"]) ||
    !($bind_dn = uid2dn($uid)) ||
    !($group = uid2group($uid))) 
   array_push($errors, "Internal Error: could not get Authentication Information");

if (isset($_SESSION['base_dn'])) $base_dn = $_SESSION['base_dn'];
   else $base_dn = 'k=kolab' ;

$myself = $_SERVER['PHP_SELF'];

if (isset($_SESSION['ldap_server'])) $ldap_server = $_SESSION['ldap_server'];
   else $ldap_server = '127.0.0.1';

if (isset($_SESSION['ldap_port'])) $ldap_port = $_SESSION['ldap_port'];
   else $ldap_port = 389;

//JMD: use myldap_connect
if (!$errors && !($groupmod_link = myldap_connect($ldap_server,$ldap_port)) || !ldap_bind($groupmod_link,$bind_dn,$_SERVER["PHP_AUTH_PW"])) 
   array_push($errors, "Communication Error: could not query ldap://$ldap_server:$ldap_port ".ldap_error($groupmod_link));   

$uidtodo=$_GET['uid_0'];
if(!$uidtodo) {
  $uidtodo=rtrim(substr(strstr($uidpart,'='),1),', ');
}

if (!$errors) {
  if($newgid!=$origgid) {
    if($origgid) {
      if($newgid) {
        echo "<pre>Removing user $uidtodo from group $origgid</pre>";
        groupdel($origgid,$uidtodo);
      } else {
        echo "<pre>Removing user $uidtodo from *all* groups</pre>";
        groupdel("*",$uidtodo);
      }
    } 
    if($newgid) {
      if($origgid) { 
        echo "<pre>Adding user $uidtodo to group $newgid</pre>";
      }
      groupadd($newgid,$uidtodo);
    }
  }
}

function groupdel($grp,$uidtodo) {
  global $groupmod_link, $base_dn,$errors;
  $groupmod_filter="(&(objectclass=posixGroup)(gidNumber=$grp))";
  $groupmod_result = ldap_search($groupmod_link, $base_dn, $groupmod_filter);
  if ($groupmod_result) {
     ldap_sort($groupmod_link,$groupmod_result,'cn');
     $groupmod_entry = ldap_first_entry($groupmod_link, $groupmod_result);
     if (!$groupmod_entry) { 
        print("No groups!");
     } else {
        while ($groupmod_entry) {   
           $groupmod_dn = ldap_get_dn($groupmod_link,$groupmod_entry);
           $groupmod_attrs = ldap_get_attributes($groupmod_link, $groupmod_entry);
           //echo "<pre><b>$groupmod_dn";
           $groupcount=$groupmod_attrs['memberUid']['count'];
           $groupcountorig=$groupcount;
           if($groupcount==0) {
             //echo "  (empty)</b></pre>";             
           } else {
             //echo "</b></pre>";
             //echo "<pre>Before Remove: ";print_r($groupmod_attrs['memberUid']);echo "</pre>";           
             unset($groupmod_attrs['memberUid']['count']);
           
             foreach ($groupmod_attrs['memberUid'] as $key => $value) {
               if($value==$uidtodo) {
                  unset($groupmod_attrs['memberUid'][$key]);
                  $groupcount--;
               }
             }
             if($groupcount==0) {
                //echo "<pre><b>Deleted!</b></pre>";
             } else {
                //echo "<pre>After Remove: ";print_r($groupmod_attrs['memberUid']);echo "</pre>";
             }
           }
           if($groupcountorig!=$groupcount) {
             
             for($i=0;$i<$groupmod_attrs['count'];$i++) {
               unset($groupmod_attrs[$i]);
             }
             unset($groupmod_attrs['count']);
             foreach ($groupmod_attrs  as $key => $value) {
                  unset($groupmod_attrs[$key]['count']);
             }

             //echo "<pre>FINAL: ";print_r($groupmod_attrs);echo "</pre>";             

             $groupmod_status=ldap_modify($groupmod_link,$groupmod_dn,$groupmod_attrs);
             if(!$groupmod_status) {
               array_push($errors, "Could not remove $uidtodo from $groupmod_dn");
             }
           }           
           $groupmod_entry = ldap_next_entry($groupmod_link, $groupmod_entry);
        } 
        ldap_free_result($groupmod_result);
     }
  } else { 
     array_push($errors, "Communication Error: ldap server did not answer query for group information");
  }
}

function groupadd($grp,$uidtodo) {
  global $groupmod_link, $base_dn,$errors;
  $groupmod_filter="(&(objectclass=posixGroup)(gidNumber=$grp))";
  $groupmod_result = ldap_search($groupmod_link, $base_dn, $groupmod_filter);
  if ($groupmod_result) {
     ldap_sort($groupmod_link,$groupmod_result,'cn');
     $groupmod_entry = ldap_first_entry($groupmod_link, $groupmod_result);
     if (!$groupmod_entry) { 
        print("No groups!");
     } else {
        while ($groupmod_entry) {   
           $groupmod_dn = ldap_get_dn($groupmod_link,$groupmod_entry);
           $groupmod_attrs = ldap_get_attributes($groupmod_link, $groupmod_entry);
           //echo "<pre><b>$groupmod_dn";
           $groupcount=$groupmod_attrs['memberUid']['count'];
           if($groupcount==0) {
             //echo "  (empty)</b></pre>";             
             $groupmod_attrs['memberUid']=array();
           } else {
             //echo "</b></pre>";
             //echo "<pre>Before Add: ";print_r($groupmod_attrs['memberUid']);echo "</pre>";           
           }
           array_push($groupmod_attrs['memberUid'],$uidtodo);
           //echo "<pre>After Add: ";print_r($groupmod_attrs['memberUid']);echo "</pre>";
             
           for($i=0;$i<$groupmod_attrs['count'];$i++) {
             unset($groupmod_attrs[$i]);
           }
           unset($groupmod_attrs['count']);
           foreach ($groupmod_attrs  as $key => $value) {
             unset($groupmod_attrs[$key]['count']);
           }
           //echo "<pre>FINAL: ";print_r($groupmod_attrs);echo "</pre>";             

           $groupmod_status=ldap_modify($groupmod_link,$groupmod_dn,$groupmod_attrs);
           if(!$groupmod_status) {
             array_push($errors, "Could not remove $uidtodo from $groupmod_dn");
           }
           $groupmod_entry = ldap_next_entry($groupmod_link, $groupmod_entry);
        } 
        ldap_free_result($groupmod_result);
     }
  } else { 
     array_push($errors, "Communication Error: ldap server did not answer query for group information");
  }
}

ldap_close($groupmod_link);

if ($errors) {
   print "There were errors: ";
   foreach ($errors as $message) echo $message;
}

?>
