<?
/*
 (c) 2003 Tassilo Erlewein <tassilo.erlewein@erfrakon.de>
 (c) 2003 Martin Konold <martin.konold@erfrakon.de>
 (c) 2004 Jean-Michel Dault <jmdault@mandrakesoft.com>
 This program is Free Software under the GNU General Public License (>=v2).
 Read the file COPYING that comes with this packages for details.
*/

function clean_data ($dummy) {
      // Remove any characters that you do not expect from user input
      $dummy = strip_tags(stripslashes(trim($dummy)));
//      $dummy = preg_replace ("/[^A-Za-z0-9\[\]]/", "", $dummy);
      return $dummy;
}

//JMD: use LDAP V3
function myldap_connect ($hostname,$port="") {
   if($port) {
      $conn=ldap_connect($hostname,$port);
   } else {
      $conn=ldap_connect($hostname);
   }
   @ldap_set_option($conn, LDAP_OPT_PROTOCOL_VERSION, $_SESSION['ldap_version']);
   return($conn);
} 

function uid2fn ($uid)
{
   $fn = FALSE;
   //JMD: use myldap_connect
   $conn=myldap_connect($_SESSION["ldap_server"],$_SESSION["ldap_port"]);
   if ($conn) {
      if ((ldap_bind($conn, $_SESSION["php_dn"],$_SESSION["php_pw"]))) {
          $result = ldap_search($conn, $_SESSION["base_dn"],
                "(&(objectclass=inetOrgPerson)(uid=$uid))");
          if ($result) {
             $entry = ldap_first_entry($conn,$result);
             if ($entry) {
	        $cn = ldap_get_values($conn,$entry,"cn");
		$sn = ldap_get_values($conn,$entry,"sn");
		$fn = substr($cn[0],0, strpos($cn[0],$sn[0]));
             } else print "could not get dn for uid=$uid";
             ldap_free_result($result);
          } else print "could not find object for uid=$uid";
      } else print "uid2fn: could not bind anonymously";
      ldap_close($conn);
   } else print "uid2fn: could not connect to ldap://".$_SESSION["ldap_server"].":".$_SESSION["ldap_port"];
   return $fn;
}

function uid2cn ($uid)
{
   $fn = FALSE;
   //JMD: use myldap_connect
   $conn=myldap_connect($_SESSION["ldap_server"],$_SESSION["ldap_port"]);
   if ($conn) {
      if ((ldap_bind($conn, $_SESSION["php_dn"],$_SESSION["php_pw"]))) {
          $result = ldap_search($conn, $_SESSION["base_dn"],
                "(&(objectclass=inetOrgPerson)(uid=$uid))");
          if ($result) {
             $entry = ldap_first_entry($conn,$result);
             if ($entry) $cn = ldap_get_values($conn,$entry,"cn");
                else print "could not get dn for uid=$uid";
             ldap_free_result($result);
          } else print "could not find object for uid=$uid";
      } else print "uid2cn: could not bind anonymously";
      ldap_close($conn);
   } else print "uid2cn: could not connect to ldap://".$_SESSION["ldap_server"].":".$_SESSION["ldap_port"];
   return $cn[0];
}

function uid2dn ($uid)
{
   $dn = FALSE;
   //JMD: use myldap_connect
   $conn=myldap_connect($_SESSION["ldap_server"],$_SESSION["ldap_port"]);
   if ($conn) {
      if ((ldap_bind($conn, $_SESSION["php_dn"],$_SESSION["php_pw"]))) {
          $result = ldap_search($conn, $_SESSION["base_dn"],
                "(&(objectclass=inetOrgPerson)(uid=$uid))");
          if ($result) {
             $entry = ldap_first_entry($conn,$result);
             if ($entry) {
                $dn = ldap_get_dn($conn,$entry);
             } else {
	        $dn = "";
                //print "could not get dn for uid=$uid";
             }
             ldap_free_result($result);
          } else print "could not find object for uid=$uid";
      } else print "uid2dn: could not bind anonymously";
      ldap_close($conn);
   } else print "uid2dn: could not connect to ldap://".$_SESSION["ldap_server"].":".$_SESSION["ldap_port"];
   return $dn;
}



function uid2group($uid)
{
   $group = "user";
   //JMD: use myldap_connect
   $conn=myldap_connect($_SESSION["ldap_server"],$_SESSION["ldap_port"]);
   if ($conn) {
      $rc = ldap_bind($conn, $_SESSION["php_dn"],$_SESSION["php_pw"]);
      if ($rc == TRUE) {
          $dn = uid2dn($uid);
	  if ($dn) {
             $filter = "(member=$dn)";
	     $result = ldap_search($conn, "cn=maintainer,".$_SESSION["base_dn"], $filter);
	     if (ldap_count_entries($conn, $result) > 0) $group = "maintainer";
             if ($result) ldap_free_result($result);
	     $result = ldap_search($conn, "cn=admin,".$_SESSION["base_dn"], $filter);
	     if (ldap_count_entries($conn, $result) > 0) $group = "admin";
             if ($result) ldap_free_result($result);
	  }
      } else print "uid2group: could not bind anonymously";
      ldap_close($conn);
   } else print "uid2group: could not connect to ldap://".$_SESSION["ldap_server"].":".$_SESSION["ldap_port"];
   return $group;
}


function dn2uid ($dn)
{
   $uid = "";
   //JMD: use myldap_connect
   $conn=myldap_connect($_SESSION["ldap_server"],$_SESSION["ldap_port"]);
   if ($conn) {
      if ((ldap_bind($conn, $_SESSION["php_dn"],$_SESSION["php_pw"]))) {
          $result = ldap_read($conn, $dn, "(objectclass=*)");
          if ($result) {
             $entry = ldap_first_entry($conn,$result);
             if ($entry) {
                $tmp = ldap_get_values($conn,$entry,'uid');
                $uid = $tmp[0];
             } else print "could not get uid for dn=$dn";
             ldap_free_result($result);
          } else print "could not find object for dn=$dn";
      } else print "dn2uid: could not bind anonymously";
      ldap_close($conn);
   } else print "dn2uid: could not connect to ldap://".$_SESSION["ldap_server"].":".$_SESSION["ldap_port"];
   return $uid;
}

?>
