<?
/*
 (c) 2003 Tassilo Erlewein <tassilo.erlewein@erfrakon.de>
 (c) 2003 Martin Konold <martin.konold@erfrakon.de>
 (c) 2004 Jean-Michel Dault <jmdault@mandrakesoft.com>
 This program is Free Software under the GNU General Public License (>=v2).
 Read the file COPYING that comes with this packages for details.
*/
  include("head.php");
  This("maintainer/create_maintainer.php?action=create");
  Head();
  include("../include/checks.php");
?>

<TABLE WIDTH="100%" CELLSPACING=0 CELLPADDING=0 BORDER=0>

<?
function debug ($a) {
// print "debug: $a<br>\n";
}


debug("debug is on");

$errors = array();
$valid_actions = array('save','firstsave','modify','create','delete','kill');

if (!empty($HTTP_GET_VARS['action']) && 
    in_array($HTTP_GET_VARS['action'],$valid_actions)) $action = trim(urldecode($HTTP_GET_VARS['action']));
   else array_push($errors, "Error: need valid action to proceed");

$dn="";
if (!empty($HTTP_GET_VARS['dn'])) $dn = trim(urldecode($HTTP_GET_VARS['dn']));

if (!($uid = $_SERVER['PHP_AUTH_USER']) ||
    !($bind_dn = uid2dn($uid)) ||
    !($group = uid2group($uid)))
   array_push($errors, "Internal Error: could not get Authentication Information");

if (!$errors && $group != "admin")  
   array_push($errors, "Error: You don't have the required Permissions"); 

debug("givenuid=$uid, bind_dn=$bind_dn, dn='$dn', group=$group");

$myself = $_SERVER['PHP_SELF'];

if (!empty($_SESSION['ldap_server'])) $ldap_server = $_SESSION['ldap_server'];
   else $ldap_server = '127.0.0.1';

if (!empty($_SESSION['ldap_port'])) $ldap_port = $_SESSION['ldap_port'];
   else $ldap_port = 389;

$attributes = array ( 'cn', 'sn', 'uid', 'userPassword');

$utf8 = array ( 'sn', 'cn' );

function to_utf8 ($a)
{
   global $utf8;
   global $attributes;
   foreach ($attributes as $attr) {
      if (!in_array($attr,$utf8) || empty($a[$attr])) continue;
      if (is_array($a[$attr])) {
         $index = 0;
         while (!empty($a[$attr][$index])) {
            $a[$attr][$index] = utf8_encode($a[$attr][$index]);
            $index++;
         }
      } elseif (!empty($a[$attr])) $a[$attr] = utf8_encode($a[$attr]);
   }
   return $a;
}

function from_utf8 ($a)
{
   global $utf8;
   global $attributes;
   foreach ($attributes as $attr) {
      if (!in_array($attr,$utf8) || empty($a[$attr])) continue;
      if (is_array($a[$attr])) {
         $index = 0;
         while (!empty($a[$attr][$index])) {
            $a[$attr][$index] = utf8_decode($a[$attr][$index]);
            $index++;
         }
      } elseif (!empty($a[$attr])) $a[$attr] = utf8_decode($a[$attr]);
   }
   return $a;
}

$beautify = array (
      'sn' => 'Surname', 'uid' => 'Unique UserID', 'userPassword' => 'Password', 
      'firstname' => 'First Name', 'lastname' => 'Last Name');

function dobeautify ($a)
{
   global $beautify;
   if (array_key_exists($a, $beautify)) return $beautify[$a];
   return $a;
}

$comment = array(
   'firstname' => 'Required', 'sn' => 'Required',
   'password_0' => 'Required', 'password_1' => 'Required',
   'uid' => 'Required' );

function comment ($a)
{
   global $comment;
   if (array_key_exists($a, $comment)) return $comment[$a];
   return '';
}

function fill_up($a)
{
   global $attributes;
   foreach ($attributes as $attr) {
      if ($attr == 'uid' || $attr == 'mail') continue;
      if (empty($a[$attr])) $a[$attr] = array();
   }
   return $a;
}

$missing_input = 0;

function missing_input ()
{
   global $missing_input;
   global $errors;
   
   if (!$missing_input) {
      $missing_input++;
      array_push($errors, "Error: Input required");
   }
}

function is_unique ($a, $b)
{
   global $link;
   if (($result = ldap_search($link,$_SESSION['base_dn'],"(".$a."=".$b.")")) &&
       (ldap_count_entries($link,$result) <= 0))
      return TRUE;
   return FALSE;
}


$ldap_object = array('objectClass' => "inetOrgPerson");
$firstname = "";
$lastname = "";
$password_0 = "";
$password_1 = "";

//JMD: use myldap_connect
if (!$errors && (!($link = myldap_connect($ldap_server,$ldap_port)) || 
    !ldap_bind($link, $bind_dn, $_SERVER["PHP_AUTH_PW"])))
   array_push($errors, "Communication Error: could not query ldap://$ldap_server:$ldap_port ".ldap_error($link));
if (!$errors) {

   $oldmemberline = array();
   if ($dn) {
      if (($result = ldap_read($link,"cn=maintainer,".$_SESSION['base_dn'],"(objectclass=*)")) &&
          ($entry = ldap_first_entry($link, $result)) &&
          ($mattrs = ldap_get_attributes($link, $entry))) {
         $members = $mattrs['member'];
         ldap_free_result($result);
         foreach ($members as $index => $value) {
            if (strcmp($dn,$value) == 0) $oldmemberline['member'][0] = $members[$index];
         }
      } else array_push($errors, "LDAP Error: could not read maintainer group ".ldap_error($link));
   }

   if ($action == "kill") {
      if (!$dn) array_push($errors, "Error: need dn for delete operation");
      elseif ($group != "admin") 
         array_push($errors, "Error: you need administrative permissions to delete Maintainers");
      if (!$errors) {    
         print("<TR><TD><center><H1> Delete Maintainer </H1></center></TD></TR>\n");
         if (!(ldap_delete($link,$dn))) 
            array_push($errors, "LDAP Error: could delete ".utf8_decode($dn)." ".ldap_error($link));
         else {
           print("<tr><td><center> The object ".utf8_decode($dn)." is deleted </td></tr>\n");
           if (!ldap_mod_del($link, "cn=maintainer,".$_SESSION['base_dn'], $oldmemberline))
              array_push($errors, "LDAP Error: could not update maintainer group ".ldap_error($link));
         }
      } 
   } else {

      switch ($action) {

         case "firstsave":

            if (!empty($HTTP_GET_VARS['uid'])) {
               $ldap_object['uid'] = trim(urldecode($HTTP_GET_VARS['uid'])); 
            } else {
               $comment['uid'] = "<span style=\"color:#FF0000\"> Fill in uid </span>";
               missing_input();
            }

         case "save":

            if ($action == "save" && !$dn) array_push($errors, "Internal Error: need dn to save");
            if (!empty($HTTP_GET_VARS['password_0'])) $password_0 = urldecode($HTTP_GET_VARS['password_0']);
            else {
               $comment['password_0'] = "<span style=\"color:#FF0000\"> Fill in password </span>";
               missing_input();
            }
            if (!empty($HTTP_GET_VARS['password_1'])) $password_1 = urldecode($HTTP_GET_VARS['password_1']);
            else {
               $comment['password_1'] = "<span style=\"color:#FF0000\"> Fill in password </span>";
               missing_input();
            }
            if ($password_0 && $password_1) {
               if ($password_0 == $password_1) {
                  $ldap_object['userPassword'] = $password_0;
               } else {
                  $comment['password_1'] = "<span style=\"color:#FF0000\"> Password do not match </span>"; 
                  missing_input();
               }
            }
            if (!empty($HTTP_GET_VARS['firstname'])) 
               $firstname = trim(urldecode($HTTP_GET_VARS['firstname']));
            else {
               $comment['firstname'] = "<span style=\"color:#FF0000\"> Fill in firstname </span>";
               missing_input();
            }
            if (!empty($HTTP_GET_VARS['sn'])) {
               $ldap_object['sn'] = trim(urldecode($HTTP_GET_VARS['sn']));
               if (isset($firstname)) $ldap_object['cn'] = $firstname." ".$ldap_object['sn'];
            } else {
               $comment['sn'] = "<span style=\"color:#FF0000\"> Fill in lastname </span>";
               missing_input();
            }

	    $ldap_object = to_utf8($ldap_object);
	    if (!empty($ldap_object['uid']) && !is_unique('uid', $ldap_object['uid'])) {
               $comment['uid'] = "<span style=\"color:#FF0000\"> Error: This uid is already taken by another user </span>";
               missing_input();
            }
//print "ldap_object: "; print_r ($ldap_object); print "<br>";

            if ($action == "save") {
               if (!$errors) {
                  if (!empty($ldap_object['cn'])) $newdn = "cn=".$ldap_object['cn'].",".$_SESSION['base_dn'];
                     else $newdn = $dn;
                  if (strcmp($dn,$newdn) != 0) {
                     if (($result=ldap_read($link,$dn,"(objectclass=*)")) &&
                         ($entry=ldap_first_entry($link,$result)) &&
                         ($oldattrs=ldap_get_attributes($link,$entry))) {
                        $ldap_object['uid'] = $oldattrs['uid'][0];
                        if (!ldap_add($link,$newdn, $ldap_object) || !ldap_delete($link,$dn))
                           array_push($errors, "LDAP Error: could not rename ".utf8_decode($dn).
			                       " to ".utf8_decode($newdn)." ".ldap_error($link));
                        $dn = $newdn;
                     } else array_push($errors,"LDAP Error: could not read ".utf8_decode($dn)." ".ldap_error($link));
                  } else {
                     $ldap_object = fill_up($ldap_object);
                     if (!ldap_modify($link, $dn, $ldap_object))
                        array_push($errors, "LDAP Error: could not modify object ".utf8_decode($dn)." ".ldap_error($link));
                  }
               }
            }  else {
               if (!$errors) {
                  $dn = "cn=".$ldap_object['cn'].",".$_SESSION['base_dn'];
                  if ($dn && !ldap_add($link, $dn, $ldap_object)) 
                     array_push($errors, "LDAP Error: could not add object ".utf8_decode($dn)." ".ldap_error($link));
               }
               if ($errors) {
                  $action = "create";
                  print("<TR><TD><center><H1> Create New Maintainer </H1></center></TD></TR>\n");
		  $ldap_object = from_utf8($ldap_object);
                  break;
               }
            }
            $memberline = array();
            $memberline['member'][] = $dn;
            if ($oldmemberline && !ldap_mod_del($link, "cn=maintainer,".$_SESSION['base_dn'], $oldmemberline))
               array_push($errors, "LDAP Error: could not delete old info from maintainer group ".ldap_error($link));
            if (!ldap_mod_add($link, "cn=maintainer,".$_SESSION['base_dn'], $memberline)) 
               array_push($errors, "LDAP Error: could not add new info to maintainer group ".ldap_error($link));
            $action = "modify";
            print("<TR><TD><center><H1> Modify Existing Maintainer </H1></center></TD></TR>\n");
            break;

         case "create":
            print("<TR><TD><center><H1> Create New Maintainer </H1></center></TD></TR>\n");
	    //JMD Print warning
	    print("<br><br><b>Note:</b> Administrators and Maintainers are role accounts, you cannot use them for e-mail, calendar, etc. If a user needs these functions, create both an administrator/maintainer account and a regular account with different user IDs.<br>");
            break;

         case "modify":
            print("<TR><TD><center><H1> Modify Existing Maintainer </H1></center></TD></TR>\n");
	    break;

	 case "delete":
	    print("<TR><TD><center><H1> Confirm Delete Maintainer </H1></center></TD></TR>\n");
      }
      if ($dn) {
         if (($result = ldap_read($link, $dn, "(objectclass=*)")) &&
             ($entry = ldap_first_entry($link,$result)) &&
             ($ldap_object = ldap_get_attributes($link,$entry))) {
            //$myentry = array_merge_recursive($myentry, $attrs);
            $ldap_object = from_utf8($ldap_object);
            $ldap_object = fill_up($ldap_object);
            ldap_free_result($result);
         }
      }
   }
   ldap_close($link);
}   

//print "ldap_object: "; print_r ($ldap_object); print "<br>";

if ($action != "kill") {

print("<TR><TD><CENTER><form action=\"$myself\" method=\"GET\">\n");
switch ($action) {
   case "create":
      print("<input type=\"hidden\" name=\"action\" value=\"firstsave\">\n");
      break;
   case "delete":
      print("<input type=\"hidden\" name=\"action\" value=\"kill\">\n");
      break;
   default:   
      print("<input type=\"hidden\" name=\"action\" value=\"save\">\n");
}
if ($dn) print("<input type=\"hidden\" name=\"dn\" value=\"$dn\">\n");
print("<table cellspacing=0 cellpadding=3>\n");

if (is_array($ldap_object['sn'])) $lastname = $ldap_object['sn'][0];
   else $lastname = $ldap_object['sn'];
if (is_array($ldap_object['cn'])) $cn = $ldap_object['cn'][0];
   else $cn = $ldap_object['cn'];
if ($lastname) {
   $a = strlen($lastname);
   if ($cn) {
      $b = strlen($cn);
      $firstname = substr($cn, 0, $b - $a);
   }
}
if ($action == "delete") print("<tr><th> Attribute </th><th> Value </th></tr>\n");
else print("<tr><th> Attribute </th><th> Value </th><th> Comment </th></tr>\n");
print("<tr><td> First Name </td><td>\n");
if ($action == "delete") print("$firstname </td></tr>\n");
else { 
   print("<input type=\"text\" name=\"firstname\" size=25 maxlength=80 value=\"$firstname\">\n");
   print("</td><td>".(comment('firstname'))."</td></tr>\n");
}
print("<tr><td> Last Name </td><td>\n");
if ($action == "delete") print("$lastname </td></tr>\n");
else {
   print("<input type=\"text\" name=\"sn\" size=25 maxlength=80 value=\"$lastname\">\n");
   print("</td><td>".(comment('sn'))."</td></tr>\n");
}

if ($action != "delete") {
   if (is_array($ldap_object['userPassword'])) $password_0 = $password_1 = $ldap_object['userPassword'][0];
      else $password_0 = $password_1 = $ldap_object['userPassword'];
   print("<tr><td> Password </td><td>\n");
   print("<input type=\"password\" name=\"password_0\" size=25 maxlength=80 value=\"$password_0\">\n");
   print("</td><td>".(comment('password_0'))."</td></tr>\n");
   print("<tr><td> Verify Password </td><td>\n");
   print("<input type=\"password\" name=\"password_1\" size=25 maxlength=80 value=\"$password_1\">\n");
   print("</td><td>".(comment('password_1'))."</td></tr>\n");
}

print("<tr><td>".(dobeautify('uid'))."</td><td>\n");
if (is_array($ldap_object['uid'])) $uidval = $ldap_object['uid'][0];
   else $uidval = $ldap_object['uid'];
if ($action == "create") {
   print("<input type=\"text\" name=\"uid\" size=25 maxlength=80 value=\"".$uidval."\">\n");
} else {
   print ($uidval);
}
print("</td>");
if ($action != "delete") print("<td>".(comment('uid'))."</td>\n");
print("</tr></table></CENTER></TD><TR>\n");

print("<tr><td><center><table cellspacing=0 cellpadding=3>\n");
print("<tr><td><input type=\"image\" src=\"../pics/button_ok.png\" name=\"apply\" value=\"Apply\"></td>\n");
if ($group == "user") {
   print("<td><a href=\"..\"> <img src=\"../pics/button_cancel.png\" alt=\"cancel\"></a></td></tr>\n");
} else {
   print("<td><a href=\"index.php\"> <img src=\"../pics/button_cancel.png\" alt=\"cancel\"></a></td></tr>\n");
}
print("</center></td></tr>\n");
print("</table>\n");

}  // if $action != kill

if ($errors) {
   print("<TABLE WIDTH=\"100%\" CELLSPACING=20 CELLPADDING=0 BORDER=0>\n");
   print("<TR><TD HEIGHT=20></TD></TR>\n");
   print("<TR><TD><H3> There were Errors : </H3></TD></TR>\n");
   print("<TR><TD>\n");
   foreach ($errors as $message) print("<span style=\"color:#FF0000\">".$message."</span><br>");
   print("</TD></TR>\n");
   print("</TABLE>\n");
}

print("</TABLE>\n");

Foot();
?>
