<?php
/*
 (c) 2002 Alexandros Vellis <avel@users.sourceforge.net>
 (c) 2003 Tassilo Erlewein <tassilo.erlewein@erfrakon.de>
 (c) 2003 Martin Konold <martin.konold@erfrakon.de>
 This program is Free Software under the GNU General Public License (>=v2).
 Read the file COPYING that comes with this packages for details.
*/

/* These are just my own wrapper functions around sieve-php.lib, with error
 * handling et al.
 */

include "../include/sieve-php.lib";

$newscript = "require \"vacation\";\n# keep next two lines:\n# return date: 2002-10-22\n# notification interval: 7\nvacation :days 7\n \"This is to inform you that I'm out of office until 22 October 2002.\";";
//$newscript ="redirect \"af@erfrakon.de\";";
print "upload of script: $newscript\n\n\n";

$ServerAddress = "127.0.0.1";
$sieveport = 2000;
$username = "achim";
$acctpass = "qw507er";

$action = "delete";
$scriptname = "kmail-vacation.siv";
//$scriptname = "phpscript";

$sieve=new sieve($ServerAddress, $sieveport, $username, $acctpass, $username);
// print "($ServerAddress, $sieveport, $username, $acctpass, $username)";


if (!($sieve->sieve_login())){
    $errormsg = ("Could not log on to timsieved daemon on your IMAP server");
    $errormsg .= " " . $ServerAddress.".<br />";
    $errormsg .= ("in order to save your rules.") . "<br />";
    $errormsg .= ("Please contact your administrator.");
    print($errormsg);
    exit;
} else {
    print "Welcome! Login successful.\n";
}
if ($action == "set" ) {
   upload_script ($newscript);

   print("\naction: $action.\n\n");
   if(!($sieve->sieve_setactivescript($scriptname))){
     /* Just to be safe. */
      $errormsg = ("Could not set active script on your IMAP server");
      $errormsg .= " " . $ServerAddress.".<br />";
      $errormsg .= ("Please contact your administrator.");
      print($errormsg);
      exit;
   }
} else {
    delete_script ();
    print("\naction: $action.\n\n");
}
$sieve->sieve_logout();


function upload_script ($newscript) {
	global $sieve;
	global $scriptname;

	print "<pre>Sending the script...";
	print $newscript;
	print "</pre>";

	if($sieve->sieve_sendscript($scriptname, stripslashes($newscript))) {
		return true;
	        print "Your rules have been successfully updated.<br />"; 
	} else {
		print "Unable to load script to server.  See server response below:<br />
		<blockquote><font color=#aa0000>";
		if(is_array($sieve->error_raw)) {
			foreach($sieve->error_raw as $error_raw)
                        print $error_raw."<br>";
		} else {
                	print $sieve->error_raw."<br>";
		}
		print "</font></blockquote>";
		return false;
	}
}

function delete_script () {
	global $sieve;
	global $scriptname;

	if($sieve->sieve_deletescript($scriptname)) {
		return true;
	} else {
		print 'Unable to delete script from server. See server response below:<br />
		<blockquote><font color="red">';
		if(is_array($sieve->error_raw)) {
			foreach($sieve->error_raw as $error_raw)
				print $error_raw."<br>";
		} else {
			print $sieve->error_raw."<br>";
		}
	print "</font></blockquote>";
	return false;
	}
}

?>
